require("dotenv").config();
const nodemailer = require("nodemailer");
const handleBars = require("nodemailer-express-handlebars");

module.exports = function (receiverEmail,receiverName,messageSubject,messageBody,templateName) {
  this.receiverEmail = receiverEmail;
  this.receiverName = receiverName;
  this.messageSubject = messageSubject;
  this.messageBody = messageBody;
  this.templateName = templateName;
  

  this.shootEmail = async function () {
    let transporter = nodemailer.createTransport({
      host: "smtp.gmail.com",
      port: 587,
      secure: false,
      auth: {
        user: process.env.NODE_MAILING_ID,
        pass: process.env.NODE_MAILING_PASSWORD,
      },
    });

    transporter.use(
      "compile",
      handleBars({
        viewEngine: {
          partialsDir: "./templates/",
          defaultLayout: "",
        },
        viewPath: "./templates/",
        extName: ".handlebars",
      })
    );
      
    let mailInfo = await transporter.sendMail({
      from: process.env.NODE_MAILING_ID,
      to: receiverEmail,
      subject: messageSubject,
      text: messageBody,
      template: templateName,
      context: {
        app_name: "Smile With Pets",
        verification_link: process.env.PUBLIC_URL,
      },
    });
    // console.log(mailInfo);
    return mailInfo.messageId;
  };
};