const Admin = require("../models/Admin.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const uuid4 = require("uuid4");

//Refresh access tokens
exports.refreshAccessTokens = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const refreshAccessToken = generalHelper.mysql_real_escape_string(request.body.refreshAccessToken);

    Admin.refreshAccessTokens(refreshAccessToken, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
}


//Login Admin
exports.login = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const email = generalHelper.mysql_real_escape_string(request.body.email);
    const type = generalHelper.mysql_real_escape_string(request.body.type);
    Admin.login(email, type, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
}

//Logout Admin
exports.logout = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const refreshAccessToken = generalHelper.mysql_real_escape_string(request.body.refreshAccessToken);

    Admin.logout(refreshAccessToken, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
}


//Login Admin
exports.getReviews = (request, response) => {
  Admin.getReviews((err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
}

