/* eslint-disable no-unused-vars */
const product = require("../models/AdminProduct.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const uuid4 = require("uuid4");
const multer = require("multer");
const upload = multer({ dest: "var/www/html/assets/images/products/" });

//create
exports.Create =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id = uuid4();
    const name= generalHelper.mysql_real_escape_string(request.body.name);
    const variant_name= generalHelper.mysql_real_escape_string(request.body.variant_name);
    const description= generalHelper.mysql_real_escape_string(request.body.description);
    const price= generalHelper.mysql_real_escape_string(request.body.price);
    const discounted_price= generalHelper.mysql_real_escape_string(request.body.discounted_price);
    const internal_id= generalHelper.mysql_real_escape_string(request.body.internal_id);
    const sku= generalHelper.mysql_real_escape_string(request.body.sku);
    const brand= generalHelper.mysql_real_escape_string(request.body.brand);
    const product_size= generalHelper.mysql_real_escape_string(request.body.product_size);
    const category_id= generalHelper.mysql_real_escape_string(request.body.category_id);
    const selectedAnimals = generalHelper.mysql_real_escape_string(request.body.selectedAnimals);
    var nameimage="";
    if (request.files){
        const photo = request.files;
        for (let i = 0; i < photo.files.length; i++) {
            var productImage = photo.files[i];
            var profileImage = photo.files[i].name;
            var imagePath = process.env.ROOT_IMAGE_PATH+'products/' + profileImage;
            productImage.mv(imagePath,  function(err) {
                if(err){
                    return response.status(500).send(err);
                }
            });
        }
        product.CreateWithImage(id,photo,name,variant_name,description,price,discounted_price,internal_id,sku,brand,product_size,category_id,selectedAnimals, (err, data) => {
        if (err){
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });}
            else response.status(200).send(data);
        });
    }
    // else {
    //     product.CreateWithoutImage(id,name,variant_name,description,price,discounted_price,internal_id,sku,category_id,(err, data) => {
    //     if (err)
    //     response.status(500).send({
    //         message:
    //         err.message || "Some error occurred while update project."
    //     });
    //     else response.status(200).send(data);
    //    });
    // }
    
};
//Set Product Status
exports.setStatus =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id= generalHelper.mysql_real_escape_string(request.body.id); 
    const status= generalHelper.mysql_real_escape_string(request.body.status); 
    product.setStatus(id,status, (err, data) => {
    if (err){
        console.log(err); 
        response.status(500).send({
            message:
            err.message || "Some error occurred while update project."
        });}
        else response.status(200).send(data);
    });
};
// get 
exports.getAll = (request, response) => {
    product.getAll((err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving City."
        });
        else response.send(data);
    });
}; 







// Create Animals 
exports.animalCreate =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id = uuid4();
    const name= generalHelper.mysql_real_escape_string(request.body.animal_name);
    
    product.animalCreate(id,name, (err, data) => {
    if (err){
        console.log(err); 
        response.status(500).send({
            message:
            err.message || "Some error occurred while update project."
        });}
        else response.status(200).send(data);
    }); 
};
// get Animals
exports.getAnimal = (request, response) => {
    product.getAnimal((err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving City."
        });
        else response.send(data);
    });
}; 
