const ApiUsers = require("../models/ApiUsers.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const uuid4 = require("uuid4");

//create
exports.Register =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id = uuid4();
    const opt= "mt"+Math.floor(Math.random() * 90 + 10);
    const plan_type = 0;
    const name= generalHelper.mysql_real_escape_string(request.body.name);
    const email= generalHelper.mysql_real_escape_string(request.body.email);
    const password= generalHelper.mysql_real_escape_string(request.body.password);
    
    ApiUsers.Register(id,opt,plan_type,name,email,password, (err, data) => {
        if (err){
        console.log(err); 
        response.status(500).send({
            message:
            err.message || "Some error occurred while update project."
        });}
        else response.status(200).send(data);
    });
      
};
 //Api Login User
exports.Login = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const email = generalHelper.mysql_real_escape_string(request.body.email);
    const password = generalHelper.mysql_real_escape_string(request.body.password);
    ApiUsers.Login(email, password, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
}

//create
exports.createTemplate =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id = uuid4();
    const userId= generalHelper.mysql_real_escape_string(request.body.userId);
    const t_name= generalHelper.mysql_real_escape_string(request.body.t_name);
    const t_message= generalHelper.mysql_real_escape_string(request.body.t_message);
    
    ApiUsers.createTemplate(id,userId,t_name,t_message, (err, data) => {
        if (err){
        console.log(err); 
        response.status(500).send({
            message:
            err.message || "Some error occurred while update project."
        });}
        else response.status(200).send(data);
    });
      
};
// Update Template
exports.editTemplate =  (request, response) => { 
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const id= generalHelper.mysql_real_escape_string(request.body.id);
    const userId= generalHelper.mysql_real_escape_string(request.body.userId);
    const t_name= generalHelper.mysql_real_escape_string(request.body.t_name);
    const t_message= generalHelper.mysql_real_escape_string(request.body.t_message);
    
    ApiUsers.editTemplate(id,userId,t_name,t_message, (err, data) => {
        if (err){
        console.log(err); 
        response.status(500).send({
            message:
            err.message || "Some error occurred while update project."
        });}
        else response.status(200).send(data);
    });
      
};
//  Delete Template
exports.deleteTemplate=(request, response)=>{
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    // console.log(request.body);
    const id = generalHelper.mysql_real_escape_string(request.body.id);
    const userId = generalHelper.mysql_real_escape_string(request.body.userId);
    // console.log(id, userId)
    ApiUsers.deleteTemplate(id,userId,(err, data)  =>{
        if(err) {
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });
        }
            else response.status(200).send(data);
    });    
};
//  Change Password
exports.changePassword=(request, response)=>{
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const userId = generalHelper.mysql_real_escape_string(request.body.userId);
    const password = generalHelper.mysql_real_escape_string(request.body.password);
    ApiUsers.changePassword(userId,password,(err, data)  =>{
        if(err) {
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });
        }
            else response.status(200).send(data);
    });    
};
//  Change Signature
exports.updateSignature=(request, response)=>{
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const userId = generalHelper.mysql_real_escape_string(request.body.userId);
    const t_signature = generalHelper.mysql_real_escape_string(request.body.t_signature);
    ApiUsers.updateSignature(userId,t_signature,(err, data)  =>{
        if(err) {
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });
        }
            else response.status(200).send(data);
    });    
};
//  Update linkdin Id
exports.updateLinkedinIdCheck=(request, response)=>{
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    const userId = generalHelper.mysql_real_escape_string(request.body.userId);
    const linkedinid = generalHelper.mysql_real_escape_string(request.body.linkedinid);
    ApiUsers.updateLinkedinIdCheck(userId,linkedinid,(err, data)  =>{
        if(err) {
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });
        }
            else response.status(200).send(data);
    });    
};
//  Update Forgot Password Id
exports.sendForgot=(request, response)=>{
    if (!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Content can not be empty!"
        });
        return;
    }
    // const userId = generalHelper.mysql_real_escape_string(request.body.userId);
    const email = generalHelper.mysql_real_escape_string(request.body.email);
    ApiUsers.sendForgot(email,(err, data)  =>{
        if(err) {
            console.log(err); 
            response.status(500).send({
                message:
                err.message || "Some error occurred while update project."
            });
        }
            else response.status(200).send(data);
    });    
};