const Appointment = require("../models/Appointment.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const uuid4 = require("uuid4");

// get 
exports.vatCreate = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    var id = uuid4();
    var owner_name = generalHelper.mysql_real_escape_string(request.body.owner_name);
    var mobile_number = generalHelper.mysql_real_escape_string(request.body.mobile_number);
    var email = generalHelper.mysql_real_escape_string(request.body.email);
    var puppy_bread = generalHelper.mysql_real_escape_string(request.body.puppy_bread);
    var symptons = generalHelper.mysql_real_escape_string(request.body.symptons);
    var dob = generalHelper.mysql_real_escape_string(request.body.dob);
    var amount = generalHelper.mysql_real_escape_string(request.body.amount);
    var description = generalHelper.mysql_real_escape_string(request.body.description);
    var incubation_period = generalHelper.mysql_real_escape_string(request.body.incubation_period);
    var vaccination_status = generalHelper.mysql_real_escape_string(request.body.vaccination_status);
    var weight = generalHelper.mysql_real_escape_string(request.body.weight);
    var razorpay_order_id = generalHelper.mysql_real_escape_string(request.body.razorpay_order_id);
    var razorpay_payment_id = generalHelper.mysql_real_escape_string(request.body.razorpay_payment_id);
    var razorpay_signature = generalHelper.mysql_real_escape_string(request.body.razorpay_signature);
    
    Appointment.vatCreate(id,owner_name,mobile_number,email,puppy_bread,symptons,dob,amount,description,incubation_period,vaccination_status,weight,razorpay_order_id, razorpay_payment_id, razorpay_signature, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
};  

// Consult Pet Behaviourist
exports.consultPetCreate = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    var id = uuid4();
    var owner_name = generalHelper.mysql_real_escape_string(request.body.owner_name);
    var mobile_number = generalHelper.mysql_real_escape_string(request.body.mobile_number);
    var email = generalHelper.mysql_real_escape_string(request.body.email);
    var puppy_bread = generalHelper.mysql_real_escape_string(request.body.puppy_breed);
    var dob = generalHelper.mysql_real_escape_string(request.body.dob);
    var amount = generalHelper.mysql_real_escape_string(request.body.amount);
    var description = generalHelper.mysql_real_escape_string(request.body.description);
    var vaccination_status = generalHelper.mysql_real_escape_string(request.body.vaccination_status);
    var weight = generalHelper.mysql_real_escape_string(request.body.weight);
    var razorpay_order_id = generalHelper.mysql_real_escape_string(request.body.razorpay_order_id);
    var razorpay_payment_id = generalHelper.mysql_real_escape_string(request.body.razorpay_payment_id);
    var razorpay_signature = generalHelper.mysql_real_escape_string(request.body.razorpay_signature);
    
    Appointment.consultPetCreate(id,owner_name,mobile_number,email,puppy_bread,dob,amount,description,vaccination_status,weight,razorpay_order_id, razorpay_payment_id, razorpay_signature, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
};
