const Intelligent = require("../models/Intelligent.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");

// get Offers
exports.getAll = (request, response) => {
    if(!request.query || generalHelper.isEmptyObject(request.query)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const intelligent_id = generalHelper.mysql_real_escape_string(request.query.intelligent_id);

    Intelligent.getAll(intelligent_id, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
};  

// get 
exports.getProduct = (request, response) => {
    if(!request.query || generalHelper.isEmptyObject(request.query)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const product_id = generalHelper.mysql_real_escape_string(request.query.product_id);

    Intelligent.getProduct(product_id, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 