const Newsletter = require("../models/Newsletter.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const uuid4 = require("uuid4");

// get 
exports.subscribe = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    var id = uuid4();
    var email = generalHelper.mysql_real_escape_string(request.body.email);
    
    Newsletter.subscribe(id,email, (err, data) => {
        if(err)
            response.status(401).send(err);
        else
            response.status(200).send(data);
    });
};  
