const Offers = require("../models/Offers.model.js");
const generalHelper = require("../helpers/GeneralHelper.js");

// get All Offers
exports.getAllOffers = (request, response) => {
   Offers.getAllOffers((err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
};  
// get All Offers Product
exports.getAllOfferProduct = (request, response) => {
   Offers.getAllOfferProduct((err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// get All Offers Product List
exports.getAllOfferProductList = (request, response) => {
    Offers.getAllOfferProductList((err, data) => {  
         if (err)
         response.status(500).send({ 
             message:
             err.message || "Some error occurred while retrieving Offers."
         });
         else response.send(data);
     });
 };
 // get Product With Id
exports.getProductWithId = (request, response) => {
    // console.log(request.query);
    const product_id = request.query.storeIds;
    Offers.getProductWithId(product_id,(err, data) => {  
         if (err)
         response.status(500).send({ 
             message:
             err.message || "Some error occurred while retrieving Offers."
         });
         else response.send(data);
     });
 };
 // get Product With Id
exports.getProductDetailsWithId = (request, response) => {
    // console.log(request.query);
    const product_id = generalHelper.mysql_real_escape_string(request.query.product_id);
    Offers.getProductDetailsWithId(product_id,(err, data) => {  
         if (err)
         response.status(500).send({ 
             message:
             err.message || "Some error occurred while retrieving Offers."
         });
         else response.send(data);
     });
 };
// Edit product with offers Id 
exports.editOfferProductDetailsWithId = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const offerId = generalHelper.mysql_real_escape_string(request.body.offerId);
    const selectedProduct = generalHelper.mysql_real_escape_string(request.body.selectedProduct);
   
    // console.log(offerId,selectedProduct)
    Offers.editOfferProductDetailsWithId(offerId,selectedProduct, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// Create offers 
exports.createOffers = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const offerId = generalHelper.mysql_real_escape_string(request.body.offerId);
    const selectedProduct = generalHelper.mysql_real_escape_string(request.body.selectedProduct);
   
    Offers.createOffers(offerId,selectedProduct, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// Create offers  Category
exports.createOffersCategory = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const offer_name = generalHelper.mysql_real_escape_string(request.body.offer_name);
    const discount = generalHelper.mysql_real_escape_string(request.body.discount);
    
    Offers.createOffersCategory(offer_name,discount, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// Edit offers 
exports.editOffers = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const id = generalHelper.mysql_real_escape_string(request.body.id);
    const offerId = generalHelper.mysql_real_escape_string(request.body.offerId);
    // const selectedProduct = generalHelper.mysql_real_escape_string(request.body.selectedProduct);
   
    Offers.editOffers(id,offerId, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// Delete offers 
exports.deleteOffers = (request, response) => {
    if(!request.body || generalHelper.isEmptyObject(request.body)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const offerId = generalHelper.mysql_real_escape_string(request.body.offerId);
    Offers.deleteOffers(offerId, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 
// get Offers By Id
exports.getAll = (request, response) => {
    if(!request.query || generalHelper.isEmptyObject(request.query)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const offers_id = generalHelper.mysql_real_escape_string(request.query.offers_id);

    Offers.getAll(offers_id, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
};  

// get 
exports.getProduct = (request, response) => {
    if(!request.query || generalHelper.isEmptyObject(request.query)) {
        response.status(400).send({
            message: "Invalid request format!"
        });
        return;
    }

    const product_id = generalHelper.mysql_real_escape_string(request.query.product_id);

    Offers.getProduct(product_id, (err, data) => {  
        if (err)
        response.status(500).send({ 
            message:
            err.message || "Some error occurred while retrieving Offers."
        });
        else response.send(data);
    });
}; 