const conn = require("../config/db.config");
const generalHelper = require("../helpers/GeneralHelper.js");
const jwt = require("jsonwebtoken");
const Signmailer = require("../config/mailer.config");
const mailer = require("../config/orderMailer.config");
// const nodemailer = require("nodemailer");
//const handleBars = require("nodemailer-express-handlebars");

const Admin = function(admin) {
    
}

let refreshAccessTokens = [];

Admin.refreshAccessTokens = (refreshToken, result) => {
    if(!refreshToken) {
        return result({
            "error": "No Access Token.",
            "detailedmessage": "No access token is provided. Please verify the token is correct and provided as a bearer token in the authorization header."
        });
    }
    if(!refreshAccessTokens.includes(refreshToken)) {
        return result({
            "error": "Invalid Access Token.",
            "detailedmessage": "The access token provided is not valid. Please verify the token is correct and provided as a bearer token in the authorization header."
        });
    }
    jwt.verify(refreshToken, process.env.REFRESH_ACCESS_TOKEN_SECRET, (err, user) => {
        err && console.log(err);

        refreshAccessTokens = refreshAccessTokens.filter((token) => token !== refreshToken);

        const newAccessToken = generalHelper.generateAccessToken(user);
        const newRefreshAccessToken = generalHelper.generateRefreshAccessToken(user);

        refreshAccessTokens.push(newRefreshAccessToken);

        result(null, {"accessToken": newAccessToken, "refreshAccessToken": newRefreshAccessToken});
    })
}

Admin.login = (email, type, result) => {
    conn.query(`SELECT * FROM admin WHERE email = '${email}' AND type = '${type}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            if(!generalHelper.isEmptyObject(res)) {
                //console.log(res[0]);
                if(res[0].id) {
                    const accessToken = generalHelper.generateAccessToken(res[0]);
                    const refreshAccessToken = generalHelper.generateRefreshAccessToken(res[0]);
                    
                    refreshAccessTokens.push(refreshAccessToken);
                    
                    const resp = {
                        "user": res[0],
                        "accessToken": accessToken,
                        "refreshAccessToken": refreshAccessToken
                    }
                    
                    result(null, resp);
                }
                else {
                    result({"code": "SUSPENDED", "description": "Your account has been suspended!"}, null);
                    return;
                }
            }
            else {
                result({"code": "INVALID", "description": "Invalid Credentials!"}, null);
                return;
            }
        }
    });
}

Admin.logout = (refreshAccessToken, result) => {
    refreshAccessTokens = refreshAccessTokens.filter((token) => token !== refreshAccessToken);

    result(null, {"result": "success"});
}
// get Reviews
Admin.getReviews = (result) => { 
    conn.query(`SELECT reviews.*, users.image as reviewer_image, users.name as reviewer_name,products.variant_name as variant_name,products.name as product_name FROM reviews LEFT JOIN users ON users.id = reviews.user_id LEFT JOIN products ON products.id = reviews.product_id`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
}

module.exports = Admin;
