// const mysql = require("mysql");
const { ControlCameraOutlined } = require("@material-ui/icons");
const conn = require("../config/db.config");


const order = function(order) {
    this.name = order.name;
}


// Get
order.getAll = (result) => {
    conn.query(`SELECT * FROM orders`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};

// Count Current Month Order
order.countOrder = (result) => {
    conn.query(`SELECT COUNT(*) AS total_order FROM orders WHERE MONTH(created_at) = MONTH(now()) and YEAR(created_at) = YEAR(now())`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count Current Month Total Sales 
order.totalSales = (result) => {
    conn.query(`SELECT SUM(order_amount) AS total_sales_amount FROM orders WHERE MONTH(created_at) = MONTH(now()) and YEAR(created_at) = YEAR(now())`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count Current Month Total Customer
order.totalCustomer = (result) => {
    conn.query(`SELECT COUNT(*) AS total_customer FROM users WHERE MONTH(created_at) = MONTH(now()) and YEAR(created_at) = YEAR(now())`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count Current Month Total cancel Order
order.totalCancelOrder = (result) => {
    conn.query(`SELECT COUNT(status) AS total_cancel_order FROM orders WHERE MONTH(created_at) = MONTH(now()) and YEAR(created_at) = YEAR(now()) AND status='Cancel'`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count All Order
order.countAllOrder = (result) => {
    conn.query(`SELECT COUNT(*) AS all_order FROM orders`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count All Delivered Order 
order.countAllDeliveredOrder = (result) => {
    conn.query(`SELECT COUNT(status) AS all_delivered_order FROM orders WHERE status='Delivered'`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count Current Month Total Customer
order.countAllReturnOrder = (result) => {
    conn.query(`SELECT COUNT(status) AS all_return_order FROM orders WHERE status='Return'`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};
// Count All Cancel Order
order.countAllCancelOrder = (result) => {
    conn.query(`SELECT COUNT(status) AS all_cancel_order FROM orders WHERE status='Cancel'`, (err, res) => {
        if (err) {
            console.log("error: ", err);
            result(null, err);
            return;
        }
        result(null, res);
    });
};

module.exports = order;