const conn = require("../config/db.config.js");
const generalHelper = require("../helpers/GeneralHelper.js");
const passwordHasher = require('../config/hasher.config.js');
const jwt = require("jsonwebtoken");
const Signmailer = require("../config/forgotpass.config");
const uuid4 = require("uuid4");

const ApiUsers = function(apiUsers) {
    
}

// Api User Create
ApiUsers.Register = (id,opt,plan_type,name,email,password, result) => {
  conn.query(`SELECT * FROM api_users WHERE email = '${email}'`, (err, res) => {
    if (err) {
      result({ code: 'SERVER-ERROR', description: err }, null);
      return;
    } else {
      if (res.length > 0) {
        result(
          { code: 'SUSPENDED', description: 'Email Already exists' },
          null
        );
      } else {
        passwordHasher.cryptPassword(password, (err, enc_pass) => {
          if (err) {
            result(err, null);
            return;
          } else {
            conn.query(`INSERT INTO api_users (id,opt, plan_type,name,email,password) VALUES ('${id}','${opt}','${plan_type}','${name}','${email}','${enc_pass}')`, (err, res) => {
              if (err) {
                console.log(err);
                result(err, null);
                return;
              } else {
                //var res_result = res;
                console.log(res);
                result(null, {id: res.insertId, message:"User register successfully"});
              }
            });
          }
        });
      }
    }
  });
};

// Add login Details
ApiUsers.Login = (email, password, result) => {
    conn.query(`SELECT * FROM api_users WHERE email = '${email}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            if (!generalHelper.isEmptyObject(res)) {
                passwordHasher.comparePassword(password, res[0].password, (err, isPasswordMatch) => {
                    if (err) {
                      result(err, null);
                    } else {
                      if (isPasswordMatch) {
                        if (res[0].status === 'active') {
                          // console.log(res[0]);
                          result(null, {data:res[0], mdhash:res[0].password, message:[]});
                        } else {
                          result({ code: 'SUSPENDED', description: 'Your account has been suspended!',}, null);
                        }
                      } else {
                        result(
                          { code: 'INVALID', description: 'Invalid Credentials!' },
                          null
                        );
                      }
                    }
                  }
                );
              } else {
                result({ code: 'INVALID', description: 'Invalid Credentials!' }, null);
              }
        }
    });
}

// Api User Create
ApiUsers.createTemplate = (id,userId,t_name,t_message, result) => {
  conn.query(`INSERT INTO api_template (id,user_id,t_name,t_message) VALUES ('${id}','${userId}','${t_name}','${t_message}')`, (err, res) => {
    if (err) {
      console.log(err);
      result(err, null);
      return;
    } else {
      conn.query(`SELECT * from api_template WHERE user_id='${userId}'`, (err, resp) =>{
        if (err) {
          console.log(err);
          result(err, null);
          return;
        } else {
          result(null, {messages: resp,message:"Template has been Added"});
        }
      })
    }
  });
};
// Edit Template
ApiUsers.editTemplate = (id,userId,t_name,t_message, result) => {
  conn.query(`UPDATE api_template SET  t_name = '${t_name}', t_message='${t_message}' WHERE id='${id}' AND user_id='${userId}'`, (err, res) => {
    if (err) {
      console.log(err);
      result(err, null);
      return;
    } else {
      conn.query(`SELECT * from api_template WHERE user_id='${userId}'`, (err, resp) =>{
        if (err) {
          console.log(err);
          result(err, null);
          return;
        } else {
          result(null, {messages: resp,message:"Template has been Updated"});
        }
      })
    }
  });
};
// Delete Template
ApiUsers.deleteTemplate = (id,userId, result) => {
  conn.query(`DELETE FROM  api_template WHERE id='${id}' AND user_id='${userId}'`, (err, res) => {
    if (err) {
      console.log(err);
      result(err, null);
      return;
    } else {
      conn.query(`SELECT * from api_template WHERE user_id='${userId}'`, (err, resp) =>{
        if (err) {
          console.log(err);
          result(err, null);
          return;
        } else {
          result(null, {messages: resp,message:"Template has been deleted"});
        }
      })
    }
  });
};
// Update Password
ApiUsers.changePassword = (userId,password, result) => {
  console.log(userId+ " "+ password );
  passwordHasher.cryptPassword(password, (err, enc_pass) => {
    if (err) {
      result(err, null);
      return;
    } else {
      conn.query(`UPDATE api_users SET password='${enc_pass}' WHERE id='${userId}'`, (err, res) => {
        if (err) {
          console.log(err);
          result(err, null);
          return;
        } else {
          result(null, {id: res.insertId,});
        }
      });
    }
  });
};
// Update Signature
ApiUsers.updateSignature = (userId,t_signature, result) => {
  console.log(userId+ " "+ t_signature );
  conn.query(`UPDATE api_users SET signature='${t_signature}' WHERE id='${userId}'`, (err, res) => {
    if (err) {
      console.log(err);
      result(err, null);
      return;
    } else {
      result(null, {data: res,message:"Signature  updated successfully."});
    }
  });
};
// Update Linkedin Id
ApiUsers.updateLinkedinIdCheck = (userId,linkedinid, result) => {
  console.log(userId+ " "+ linkedinid );
  conn.query(`UPDATE api_users SET linkedinid='${linkedinid}' WHERE id='${userId}'`, (err, res) => {
    if (err) {
      console.log(err);
      result(err, null);
      return;
    } else {
      result(null, {data: res,message:"Linkedin id  updated successfully."});
    }
  });
};
// Update Forgot Password Id
ApiUsers.sendForgot = (email, result) => {
  conn.query(`SELECT id, name FROM api_users WHERE email='${email}'`, (err, res) => {
    if (err) {
      result(err, null)
    }else{
      let name = res[0].name;
      let reset_pass_link = 'https://smilewithpets.com/api/user/resetpassword?id=' + res[0].id+'&email='+email;
      // send mail to user for forgot password
      new Signmailer(email, name, "Send email for forgot password!", "", "forgot-pass", reset_pass_link)
      .shootEmail() 
      .then(() => {
        result(null, {message:"Mail sent successfully"});
      })
      .catch((error) => {
          result({"code": "MAILER-FAILED", "description": error});
      })
    }
  })
};
module.exports = ApiUsers;