const shortid = require("shortid");
const conn = require("../config/db.config");
const path = require("path");

const Product = function(product) {
    
}

Product.getByCategory = (category_id, result) => {
    conn.query(`SELECT * FROM products WHERE category_id = ${category_id} AND status = 1 `, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            result(null, res);
        }
    });
}

Product.getVariants = (internal_id, result) => {
    conn.query(`SELECT * FROM products WHERE internal_id = '${internal_id}' AND status = 1`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            result(null, res);
        }
    })
}

Product.getVariantImages = (product_id, result) => {
    conn.query(`SELECT * FROM product_images WHERE product_id = '${product_id}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            result(null, res);
        }
    })
}

Product.addReview = (id, user_id, product_id, internal_id, rating, heading, written_review, attachments, result) => {
    var attachmentKeys = Object.keys(attachments);
    var media = [];

    if(attachmentKeys.length > 0) {

        Promise.all(attachmentKeys.map(async (attachmentKey) => {
            let attachment = attachments[attachmentKey];

            var attachmentName = shortid.generate()+"."+attachment.name.split(".")[1];
            var attachmentPath = path.join(__dirname, '../../public/assets/attachments/'+attachmentName);
            var url = "assets/attachments/"+attachmentName;

            return new Promise((resolve, reject) => {
                attachment.mv(attachmentPath, function(err) {
                    if(err) {
                        reject(err);
                    }
                    else {
                        media.push(url);
                        resolve();
                    }
                });
            })
        }))
        .then(() => {
            conn.query(`INSERT INTO reviews (id, user_id, product_id, internal_id, rating, heading, written_review, media) VALUES ('${id}', '${user_id}', '${product_id}', '${internal_id}', '${rating}', '${heading}', '${written_review}', '${JSON.stringify(media)}')`, (err, res) => {
                if(err) {
                    result({"code": "SERVER-ERROR", "description": err}, null);
                    return;
                }
                else {
                    result(null, res);
                }
            });
        })
        .catch((err) => {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        })
    }

    else {
        conn.query(`INSERT INTO reviews (id, user_id, product_id, internal_id, rating, heading, written_review, media) VALUES ('${id}', '${user_id}', '${product_id}', '${internal_id}', '${rating}', '${heading}', '${written_review}', '${JSON.stringify(media)}')`, (err, res) => {
            if(err) {
                result({"code": "SERVER-ERROR", "description": err}, null);
                return;
            }
            else {
                result(null, res);
            }
        });
    }
}

Product.getReviews = (internal_id, result) => {
    conn.query(`SELECT users.image as reviewer_image, users.name as reviewer_name, reviews.rating as rating, reviews.heading as heading, reviews.created_at as created_at, products.variant_name as variant_name, reviews.written_review as written_review, reviews.media as media FROM reviews LEFT JOIN users ON users.id = reviews.user_id LEFT JOIN products ON products.id = reviews.product_id WHERE products.internal_id = '${internal_id}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            result(null, res);
        }
    })
}

Product.getReviewMetrics = (internal_id, result) => {
    conn.query(`SELECT COUNT(id) as total_reviews, ROUND(AVG(rating), 2) as avg_rating FROM reviews WHERE internal_id = '${internal_id}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            result(null, res);
        }
    })
}

module.exports = Product;