const conn = require("../config/db.config");
const generalHelper = require("../helpers/GeneralHelper.js");
const jwt = require("jsonwebtoken");
const Signmailer = require("../config/mailer.config");
const mailer = require("../config/orderMailer.config");
const uuid4 = require("uuid4");
// const nodemailer = require("nodemailer");
//const handleBars = require("nodemailer-express-handlebars");

const User = function(user) {
    
}

let refreshAccessTokens = [];
// Add Refresh Access Token
User.refreshAccessTokens = (refreshToken, result) => {
    if(!refreshToken) {
        return result({
            "error": "No Access Token.",
            "detailedmessage": "No access token is provided. Please verify the token is correct and provided as a bearer token in the authorization header."
        });
    }
    if(!refreshAccessTokens.includes(refreshToken)) {
        return result({
            "error": "Invalid Access Token.",
            "detailedmessage": "The access token provided is not valid. Please verify the token is correct and provided as a bearer token in the authorization header."
        });
    }
    jwt.verify(refreshToken, process.env.REFRESH_ACCESS_TOKEN_SECRET, (err, user) => {
        err && console.log(err);
        refreshAccessTokens = refreshAccessTokens.filter((token) => token !== refreshToken);
        const newAccessToken = generalHelper.generateAccessToken(user);
        const newRefreshAccessToken = generalHelper.generateRefreshAccessToken(user);
        refreshAccessTokens.push(newRefreshAccessToken);
        result(null, {"accessToken": newAccessToken, "refreshAccessToken": newRefreshAccessToken});
    })
}
// Add register Details
User.register = (id, number_email, name, mobile, image, type, result) => {
    conn.query(`SELECT * FROM users WHERE number_email = '${number_email}' OR mobile= '${mobile}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }else {
            //console.log(res);
            if(res.length === 0) {
                if(image === "null") {
                    image = "http://localhost:3000/assets/images/default_user.png";
                }
                // if(isNaN(number_email)){
                    new Signmailer(number_email, name, "Thankyou for signing up!", "", "verify-account")
                    .shootEmail() 
                    .then(() => {
                        conn.query(`INSERT INTO users (id, number_email, mobile, name, image, type) VALUES ('${id}', '${number_email}', '${mobile}', '${name}', '${image}', '${type}')`, (err) => {
                            if(err) {
                                result({"code": "SERVER-ERROR", "description": err}, null);
                                return;
                            }else {
                                conn.query(`SELECT * FROM users WHERE number_email = '${number_email}' OR mobile= '${mobile}'`, (err, res) => {
                                    if(err) {
                                        result({"code": "SERVER-ERROR", "description": err}, null);
                                        return;
                                    }else {
                                        const accessToken = generalHelper.generateAccessToken(res[0]);
                                        const refreshAccessToken = generalHelper.generateRefreshAccessToken(res[0]);
                                        refreshAccessTokens.push(refreshAccessToken);
                                        const resp = {
                                            "user": res[0],
                                            "accessToken": accessToken,
                                            "refreshAccessToken": refreshAccessToken
                                        }
                                        result(null, resp);
                                    }
                                });
                            }
                        })
                    })
                    .catch((error) => {
                        result({"code": "MAILER-FAILED", "description": error});
                    })
            }else {
                if(res.number_email !== number_email){
                    if(image === "null") {
                        image = "http://localhost:3000/assets/images/default_user.png";
                    }
                    // if(isNaN(number_email)){
                    new Signmailer(number_email, name, "Thankyou for signing up!", "", "verify-account")
                    .shootEmail() 
                    .then(() => {
                        conn.query(`INSERT INTO users (id, number_email, mobile, name, image, type) VALUES ('${id}', '${number_email}', '${mobile}', '${name}', '${image}', '${type}')`, (err) => {
                            if(err) {
                                result({"code": "SERVER-ERROR", "description": err}, null);
                                return;
                            }else {
                                //Login-user
                                conn.query(`SELECT * FROM users WHERE number_email = '${number_email}' OR mobile= '${mobile}'`, (err, res) => {
                                    if(err) {
                                        result({"code": "SERVER-ERROR", "description": err}, null);
                                        return;
                                    }
                                    else {
                                        const accessToken = generalHelper.generateAccessToken(res[0]);
                                        const refreshAccessToken = generalHelper.generateRefreshAccessToken(res[0]);
                                        
                                        refreshAccessTokens.push(refreshAccessToken);
                                        
                                        const resp = {
                                            "user": res[0],
                                            "accessToken": accessToken,
                                            "refreshAccessToken": refreshAccessToken
                                        }
                                        
                                        result(null, resp);
                                    }
                                });
                            }
                        })
                    })
                    .catch((error) => {
                        result({"code": "MAILER-FAILED", "description": error});
                    })
                // }else{
                //     result({"code": "ALREADY-IN-USE", "description": "This account is number or email already in use"}, null);
                // }else{
                //     conn.query(`INSERT INTO users (id, number_email, name, image, type) VALUES ('${id}', '${number_email}', '${name}', '${image}', '${type}')`, (err) => {
                //         if(err) {
                //             result({"code": "SERVER-ERROR", "description": err}, null);
                //             return;
                //         }
                //         else {
                //             //Login-user
                //             conn.query(`SELECT * FROM users WHERE number_email = '${number_email}'`, (err, res) => {
                //                 if(err) {
                //                     result({"code": "SERVER-ERROR", "description": err}, null);
                //                     return;
                //                 }
                //                 else {
                //                     const accessToken = generalHelper.generateAccessToken(res[0]);
                //                     const refreshAccessToken = generalHelper.generateRefreshAccessToken(res[0]);
                                    
                //                     refreshAccessTokens.push(refreshAccessToken);
                                    
                //                     const resp = {
                //                         "user": res[0],
                //                         "accessToken": accessToken,
                //                         "refreshAccessToken": refreshAccessToken
                //                     }
                                    
                //                     result(null, resp);
                //                 }
                //             });
                //         }
                //     })
                // }
            }else {
                result({"code": "ALREADY-IN-USE", "description": "This account is number or email already in use"}, null);
                return;
                }
            }
        }
    })
}
// Check User Mail
User.checkMail = (number_email, result) => {
    conn.query(`SELECT id FROM users WHERE number_email = '${number_email}' AND type ='GOOGLE'`, (err, res) => {
        if (err) {
          result(null, err);
          return;
        } else {
            result(null, res);
        }
    });
}
// Check Mobile Number Query
User.CheckMobile = (mobile,result)=> {
    conn.query(`SELECT id FROM users WHERE mobile = '${mobile}'`, (err,res) => {
        if (err) {
            result(null, err);
            return;
          }else{
            if (res.length > 0) {
                result(null, res);
            }else{
              result({ code: "SUSPENDED", description: "No account exists with this number" }, null);
            }
          }
    })
}
// Add login Details
User.login = (number_email, type, result) => {
    conn.query(`SELECT * FROM users WHERE number_email = '${number_email}' OR mobile = '${number_email}' AND type = '${type}'`, (err, res) => {
        if(err) {
            result({"code": "SERVER-ERROR", "description": err}, null);
            return;
        }
        else {
            if(!generalHelper.isEmptyObject(res)) {
                //console.log(res[0]);
                if(res[0].id) {
                    const accessToken = generalHelper.generateAccessToken(res[0]);
                    const refreshAccessToken = generalHelper.generateRefreshAccessToken(res[0]);
                    
                    refreshAccessTokens.push(refreshAccessToken);
                    
                    const resp = {
                        "user": res[0],
                        "accessToken": accessToken,
                        "refreshAccessToken": refreshAccessToken
                    }
                    
                    result(null, resp);
                }
                else {
                    result({"code": "SUSPENDED", "description": "Your account has been suspended!"}, null);
                    return;
                }
            }
            else {
                result({"code": "INVALID", "description": "Invalid Credentials!"}, null);
                return;
            }
        }
    });
}
// User Logout Details
User.logout = (refreshAccessToken, result) => {
    refreshAccessTokens = refreshAccessTokens.filter((token) => token !== refreshAccessToken);

    result(null, {"result": "success"});
}
// Get Address Details
User.getAddresses = (user_id, result) => {
    conn.query(`SELECT * FROM addresses WHERE user_id = '${user_id}'`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
}
// Add Guest Address
User.getGuestAddresses = (result) => {
    conn.query(`SELECT * FROM guest_addresses ORDER BY ID DESC LIMIT 1 `, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
}
// Add Address 
User.addAddress = (id, user_id, full_name, mobile_number, pin_code, house_number, street, landmark, town_city, state, result) => {
    conn.query(`INSERT INTO addresses (id, user_id, full_name, mobile_number, pin_code, house_number, street, landmark, town_city, state, type) VALUES ('${id}', '${user_id}', '${full_name}', '${mobile_number}', '${pin_code}', '${house_number}', '${street}', '${landmark}', '${town_city}', '${state}', 'User')`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
}
// Add Guest Addresss
User.addGuestAddress = (id, full_name, mobile_number, pin_code, house_number, street, landmark, town_city, state, result) => {
    conn.query(`INSERT INTO guest_addresses (id, full_name, mobile_number, pin_code, house_number, street, landmark, town_city, state, type) VALUES ('${id}', '${full_name}', '${mobile_number}', '${pin_code}', '${house_number}', '${street}', '${landmark}', '${town_city}', '${state}','Guest')`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
}
// Get Order Details
User.getOrders = (user_id, result) => {
    conn.query(`SELECT orders.id as id, orders.created_at as created_at, orders.order_amount as amount, addresses.full_name as address_name, addresses.mobile_number as phone_number, addresses.pin_code as pin_code, addresses.house_number as house_number, addresses.street as street, addresses.town_city as town_city, addresses.state as state, orders.status as status, orders.order_details as details FROM orders LEFT JOIN addresses ON addresses.id = orders.address_id WHERE orders.user_id = '${user_id}' ORDER BY orders.created_at DESC`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
} 
// Add Orders Details  
User.addOrder = (id, user_id, address_id, razorpay_order_id, order_amount, order_details, product_size, result) => {
    conn.query(`SELECT number_email, name AS username FROM users WHERE id='${user_id}'`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            const email = res[0].number_email;
            const username = res[0].username;
            new mailer(email, username, "Thankyou for choosing us!", "", "order-successful")
            .shootEmail() 
            .then(() => {
                console.log("Mail sent successfully!");
            })
            .catch((error) => {
                console.log(error);
                result({"code": "MAILER-FAILED", "description": error});
            })
            conn.query(`INSERT INTO orders (id, user_id, address_id, razorpay_order_id, order_amount, order_details, product_size) VALUES ('${id}', '${user_id}', '${address_id}', '${razorpay_order_id}', '${order_amount}', '${order_details}','${product_size}')`, (err, res) => {
                if(err) {
                    return result({"code": "SERVER-ERROR", "description": err}, null);
                }
                else {
                    conn.query(`DELETE FROM cart_items`, (err, res) => {
                        if(err) {
                            return result({"code": "SERVER-ERROR", "description": err}, null);
                        }else{
                            conn.query(`DELETE FROM abandoned_carts`, (err, res) => {
                                if(err) {
                                    return result({"code": "SERVER-ERROR", "description": err}, null);
                                }else{
                                    conn.query(`DELETE FROM carts`, (err, res) => {
                                        if(err) {
                                            return result({"code": "SERVER-ERROR", "description": err}, null);
                                        }else{
                                            return result(null, res);
                                        }
                                    })
                                }
                            })
                        }
                    })
                    // return result(null, res);
                }
            });
        }
    });
}  
// Add Guest Order 
User.addGuestOrder = (id,email,username, address, razorpay_order_id, order_amount, order_details, product_size, result) => {
    new mailer(email, username, "Thankyou for choosing us!", "", "order-successful")
    .shootEmail() 
    .then(() => {
        console.log("Mail sent successfully!");
    })
    .catch((error) => {
        console.log(error);
        result({"code": "MAILER-FAILED", "description": error});
    })
    conn.query(`INSERT INTO guest_order_details (id, address, razorpay_order_id, order_amount, order_details, product_size) VALUES ('${id}', '${address}', '${razorpay_order_id}', '${order_amount}', '${order_details}','${product_size}')`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            return result(null, res);
        }
    });
}
// Cencel order Details
User.cancelOrder = (user_id,orderId,  result) => {
    conn.query(`SELECT number_email, name AS username FROM users WHERE id='${user_id}'`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }
        else {
            const email = res[0].number_email;
            const username = res[0].username;
            new mailer(email, username, "Cancel order", "", "cancel-order")
            .shootEmail() 
            .then(() => {
                conn.query(`UPDATE orders SET status="Cancel" WHERE user_id='${user_id}' AND id='${orderId}'`, (err, res) => {
                    if(err) {
                        return result({"code": "SERVER-ERROR", "description": err}, null);
                    }
                    else {
                        return result(null, res);
                    }
                });
            })
            .catch((error) => {
                // console.log(error);
                result({"code": "MAILER-FAILED", "description": error});
            })
        }
    });
}
// Add Cart Details
User.addCartItem = (user_id, cart_id, product_id, product_price, qty, product_size, result) => {
    var abandoned_carts_id = uuid4();
    conn.query(`INSERT INTO carts (cart_id, user_id) VALUES('${cart_id}', '${user_id}')`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }else{
            conn.query(`INSERT INTO abandoned_carts (abandoned_cart_id, cart_id) VALUES('${abandoned_carts_id}', '${cart_id}')`, (err, res) => {
                if(err) {
                    return result({"code": "SERVER-ERROR", "description": err}, null);
                }else{
                    var cart_item_id = uuid4();
                    conn.query(`INSERT INTO cart_items (id, cart_id, product_id, quantity, price) VALUES('${cart_item_id}', '${cart_id}', '${product_id}', '${qty}', '${product_price}')`, (err, res) => {
                        if(err) {
                            return result({"code": "SERVER-ERROR", "description": err}, null);
                        }else{
                            return result(null, res);
                        }
                    })
                    
                }
            });
        }
    })
}
// Update Cart Details
User.updateCartItem = (user_id,cart_id, qty, result) => {
    conn.query(`UPDATE cart_items SET quantity='${qty}' WHERE cart_id='${cart_id}'`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }else{
            return result(null, res);
        }
    })
}
// Get Cart Details
User.getCartDetails = (user_id, result) => {
    conn.query(`SELECT carts.cart_id AS Id, products.id AS id,products.name,products.variant_name,products.description,products.thumbnail,products.price,products.discounted_price,products.internal_id,products.sku,products.model,products.brand_id,products.product_size,products.category_id,products.is_premium,products.status,cart_items.quantity AS qty FROM carts LEFT JOIN cart_items ON carts.cart_id = cart_items.cart_id INNER JOIN products ON cart_items.product_id = products.id WHERE carts.user_id = '${user_id}'`, (err, res) => {
        if(err) {
            return result({"code": "SERVER-ERROR", "description": err}, null);
        }else{
            return result(null, res);
        }
    })
}
// Update Cart Details
User.deleteCartItem = (user_id,cart_id, qty, result) => {
    if(Number(qty) === 0){
        conn.query(`DELETE FROM cart_items WHERE cart_id='${cart_id}'`, (err, res) => {
            if(err) {
                return result({"code": "SERVER-ERROR", "description": err}, null);
            }else{
                conn.query(`DELETE FROM abandoned_carts WHERE cart_id='${cart_id}'`, (err, res) => {
                    if(err) {
                        return result({"code": "SERVER-ERROR", "description": err}, null);
                    }else{
                        conn.query(`DELETE FROM carts WHERE cart_id='${cart_id}'`, (err, res) => {
                            if(err) {
                                return result({"code": "SERVER-ERROR", "description": err}, null);
                            }else{
                                return result(null, res);
                            }
                        })
                    }
                })
            }
        })
    }
    
}
// // Get Cart Details
// User.getCartDetails = (user_id,cart_id, result) => {
//     conn.query(`SELECT products.id,products.name,products.variant_name,products.description,products.thumbnail,products.price,products.discounted_price,products.internal_id,products.sku,products.model,products.brand_id,products.product_size,products.category_id,products.is_premium,products.status FROM carts LEFT JOIN cart_items ON carts.cart_id = cart_items.cart_id INNER JOIN products ON cart_items.product_id = products.id WHERE carts.user_id = '${user_id}' AND cart_items.cart_id='${cart_id}'`, (err, res) => {
//         if(err) {
//             return result({"code": "SERVER-ERROR", "description": err}, null);
//         }else{
//             return result(null, res);
//         }
//     })
// }
// // Get Cart 
// User.getCart = (user_id, result) => {
//     conn.query(`SELECT carts.cart_id,cart_items.quantity AS qty FROM carts LEFT JOIN cart_items ON carts.cart_id = cart_items.cart_id WHERE carts.user_id = '${user_id}'`, (err, res) => {
//         if(err) {
//             return result({"code": "SERVER-ERROR", "description": err}, null);
//         }else{
//             return result(null, res);
//         }
//     })
// }
module.exports = User;
