module.exports = app => {
    const product = require("../controllers/Product.controller.js");
    const generalHelper = require("../helpers/GeneralHelper.js");

    //Get products by category
    app.get("/product/list", product.getByCategory);

    //Get product variants
    app.get("/product/:internal_id/variant/list", product.getVariants);

    //Get product variant images
    app.get("/product/:product_id/variant/images", product.getVariantImages);

    //Create review for a product
    app.post("/product/review/create", generalHelper.authenticateToken, product.addReview);

    //Get product reviews
    app.get("/product/:internal_id/review/list", product.getReviews);

    //Get reviews metrics
    app.get("/product/:internal_id/review/metrics", product.getReviewMetrics);

}