module.exports = app => {
    const user = require("../controllers/User.controller.js");
    const generalHelper = require("../helpers/GeneralHelper.js");

    //Refesh Tokens
    app.post("/user/token/refresh", user.refreshAccessTokens); 
    //Count current month user 
    // app.get("/user/count-users", user.countUsers);
    //Register user
    app.post("/user/register", user.register);
    //Login user
    app.post("/user/login", user.login);
    //Check user email
    app.get("/user/checkemail", user.checkMail);
    //Check user mobile number
    app.get("/user/check-mobile-number", user.CheckMobile);
    //Logout user
    app.post("/user/logout", user.logout);
    //Get Guest Addresses
    app.get("/user/guest-address/list",  user.getGuestAddresses);
    //Add guest addresses
    app.post("/user/guest-address/create", user.addGuestAddress);
    //Add Guest Order
    app.post("/user/guest-order/create", user.addGuestOrder); 
    //Add addresses
    app.post("/user/address/create", generalHelper.authenticateToken, user.addAddress);
    //Get orders
    app.get("/user/:user_id/order/list", generalHelper.authenticateToken, user.getOrders);
    //Add order
    app.post("/user/order/create", generalHelper.authenticateToken, user.addOrder); 
    //Get addresses
    app.get("/user/:user_id/address/list", generalHelper.authenticateToken, user.getAddresses);
    //Add Cancel Order
    app.post("/user/order/cancel-order", generalHelper.authenticateToken, user.cancelOrder);
    // Add Cart Item
    app.post("/cart/item/add", generalHelper.authenticateToken , user.addCartItem);
    // Update Cart Item
    app.post("/cart/item/update", generalHelper.authenticateToken , user.updateCartItem);
    // Delete Cart Item
    app.post("/cart/item/delete", generalHelper.authenticateToken , user.deleteCartItem);
    //Get Cart Details
    // app.get("/user/cart/get-cart", generalHelper.authenticateToken, user.getCart);
    //Get Cart Details
    app.get("/user/cart/get-cart-details", generalHelper.authenticateToken, user.getCartDetails);
     
}