async function handleWebhook(ctx) {
    const webhookData = ctx.request.body;
    console.log(webhookData);
    const webhookSecret = "AhmadZushan";
    const { validateWebhookSignature } = require("razorpay/dist/utils/razorpay-utils");
    const webhookSignature = ctx.request.headers["x-razorpay-signature"];
    const isWebhookValid = validateWebhookSignature(JSON.stringify(webhookData), webhookSignature, webhookSecret);
 
    if (!isWebhookValid) {
      ctx.throw(400, "Invalid webhooksignature");
    }
    if (webhookData.event === "subscription.activated") {
        const subscription = webhookData.payload.subscription.entity;
        await strapi.services["razorpay-subscription-ledger"].handleSubscriptionActivated(subscription);
    } else if (webhookData.event === "subscription.halted") {
        const subscription = webhookData.payload.subscription.entity;
        await strapi.services["razorpay-subscription-ledger"].handleSubscriptionHalted(subscription);
    } else if (webhookData.event === "subscription.charged") {
        const subscription = webhookData.payload.subscription.entity;
        const payment = webhookData.payload.payment.entity;
        await strapi.services["razorpay-installment-ledger"].handleSubscriptionCharged(subscription, payment);
    }
    const subscriptionLedger = await strapi.services["razorpay-subscription-ledger"].findOne({ subscription_id: subscription.id });
    if (!subscriptionLedger) {
        ctx.throw(400, "Subscription ledger entry not found");
    }
    // Create a new installment payment ledger entry when the subscription is charged
    ctx.status = 200;
}
 